/*
 * Luefter_tiny_pwm2.ino
 * 
 * Copyright 2014 Rainer Keil <rkeil@online.de>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 * 
 * 
 */


#include <util/delay.h>    // Adds delay_ms and delay_us functions


//               +--\_/--+
//	Reset   -|1	8|- VCC
//	3 / A3  -|2	7|- 2 / A1
//	4 / A2  -|3	6|- 1 (PWM)
//     GND      -|4	5|- 0 (PWM)
//               +-------+
//
//	int pin2 = 3;
//	int pin3 = 4;
//	int pin5 = 0;
//	int pin6 = 1;
//	int pin7 = 2;

#define schalter_in		3		// pin2   Schalter
#define poti_in	    	        A2		// pin3   Analog Eingang (Poti)
#define pwm_out			0		// pin5	  PWM Signal
#define tacho_in		1		// pin6   Tachosignal
#define ldr_in			A1		// pin7   Analog Eingang (LDR vom Laser)


#define OFF_VALUE		10

int schalter;
int poti;
int ldr;
int tacho_time;
int pwm_out_value;


/*
 * name:	setup
 * @param	none
 * @return	none
 * 
 */

void setup() {                

  TCCR0B = TCCR0B & 0b11111000 | 0b010 ; // Set pin 5 PWM frequency to 31250/8 Hz  ==> standard delay ist verstellt !!!
  
  schalter = 0;
  poti = OFF_VALUE;
  ldr = 0;
  tacho_time = 0;
  pwm_out_value = 255-poti/4;
  analogWrite(pwm_out,pwm_out_value);
  
}

// the loop routine runs over and over again forever:
void loop() {
  poti = analogRead(poti_in);			// poti einlesen
  
  schalter = digitalRead(schalter_in);
  
 if(schalter == 1 ) {		// OFF Switch ??
	  poti= OFF_VALUE;
  }
  
  pwm_out_value = 255-poti/4;	
  
  analogWrite(pwm_out,pwm_out_value); // skalierten PWM Wert Ausgeben
  
  _delay_ms(10);

}
